%Questo agente  in grado di inserire i voti della giornata attuale nel centro di tuple domenica e andare poi a calcolare i 
%punteggi ottenuti da ogni squadra, inserendoli nel rispettivo centro di tuple di ogni formazione.

:- load_library('alice.tucson.api.Tucson2PLibrary').
:- solve(go).
go:-
	enter_context([agent_id(gazzettadomenica)]),
	text_from_file('specification\regoledomenica.pl',X),
	domenica ? set_spec(X),	
	iportieri(0),	
	idifensori(0),
	icentrocampisti(0),
	iattaccanti(0),
	nuovivoti,
	nuovototale,
	calcolopunteggio,
	calcolopunteggio1(0,0),
	calcolopunteggio2(0,0),
	calcolopunteggio3(0,0),
	result(0,0),
	calcolopunteggioa,
	calcolopunteggioa1(0,0),
	calcolopunteggioa2(0,0),
	calcolopunteggioa3(0,0),
	result1(0,0),
	calcolopunteggiob,
	calcolopunteggiob1(0,0),
	calcolopunteggiob2(0,0),
	calcolopunteggiob3(0,0),
	result2(0,0),
	calcolopunteggioc,
	calcolopunteggioc1(0,0),
	calcolopunteggioc2(0,0),
	calcolopunteggioc3(0,0),
	result3(0,0),
	write('Nuovi voti calcolati'),nl,
	exit_context.
	
%Cancellazione dei voti della giornata precedente
iportieri(V):-
	domenica ? inp(portieri(X,Z)),
	P is V+1,
	(P==3;iportieri(P)).
idifensori(V):-
	domenica ? inp(difensori(X,Z)),
	P is V+1,
	(P==8;idifensori(P)).
icentrocampisti(V):-
	domenica ? inp(centrocampisti(X,Z)),
	P is V+1,
	(P==8;icentrocampisti(P)).
iattaccanti(V):-
	domenica ? inp(attaccanti(X,Z)),
	P is V+1,
	(P==6;iattaccanti(P)).

%inserimento dei nuovi voti
nuovivoti:-
	domenica ? out(portieri(lupatelli,5.5)),
	domenica ? out(portieri(peruzzi,5.5)),
	domenica ? out(portieri(buffon,5)),

	domenica ? out(difensori(materazzi,5.5)),
	domenica ? out(difensori(cardone,6)),
	domenica ? out(difensori(cannavaro,6)),
	domenica ? out(difensori(bonera,6)),
	domenica ? out(difensori(maldini,7)),
	domenica ? out(difensori(tudor,7)),
	domenica ? out(difensori(nesta,7)),
	domenica ? out(difensori(zanetti,6)),

	domenica ? out(centrocampisti(gattuso,6)),
	domenica ? out(centrocampisti(dabo,6)),
	domenica ? out(centrocampisti(marchionni,6)),
	domenica ? out(centrocampisti(bresciano,6)),
	domenica ? out(centrocampisti(vieira,5)),
	domenica ? out(centrocampisti(veron,6)),
	domenica ? out(centrocampisti(pizarro,6)),
	domenica ? out(centrocampisti(pirlo,7)),

	domenica ? out(attaccanti(trezeguet,6)),
	domenica ? out(attaccanti(shevchenko,9)),
	domenica ? out(attaccanti(toni,5)),
	domenica ? out(attaccanti(adriano,5.5)),
	domenica ? out(attaccanti(corradi,6)),
	domenica ? out(attaccanti(morfeo,6)).

%Cancellazione del risultato totale di ogni formazione nella giornata precedente
nuovototale:-
	formazioni1 ? inp(totale(X)),
	formazioni2 ? inp(totale(Y)),
	formazioni3 ? inp(totale(Z)),
	formazioni4 ? inp(totale(K)).

%Calcolo dei punteggi per ogni ruolo e del risultato finale per ogni squadra
calcolopunteggio:-
	formazioni1 ? inp(portieri(A,B)),
	domenica ? rdp(portieri(A,C)),
	formazioni1 ? out(portieri(A,C)),
	risultati ? out(C).
calcolopunteggio1(Q,V):-
	formazioni1 ? inp(difensori(A,B)),
	domenica ? rdp(difensori(A,C)),
	formazioni1 ? out(difensori(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==4,risultati ? out(V1);calcolopunteggio1(P,V1)).
calcolopunteggio2(Q,V):-
	formazioni1 ? inp(centrocampisti(A,B)),
	domenica ? rdp(centrocampisti(A,C)),
	formazioni1 ? out(centrocampisti(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==4,risultati ? out(V1);calcolopunteggio2(P,V1)).
calcolopunteggio3(Q,V):-
	formazioni1 ? inp(attaccanti(A,B)),
	domenica ? rdp(attaccanti(A,C)),
	formazioni1 ? out(attaccanti(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==2,risultati ? out(V1);calcolopunteggio3(P,V1)).
result(Q,V):-
	risultati ? inp(A),
	V1 is V+A,
	P is Q+1,
	(P==4,formazioni1 ? out(totale(V1));result(P,V1)).

calcolopunteggioa:-
	formazioni2 ? inp(portieri(A,B)),
	domenica ? rdp(portieri(A,C)),
	formazioni2 ? out(portieri(A,C)),
	risultati2 ? out(C).
calcolopunteggioa1(Q,V):-
	formazioni2 ? inp(difensori(A,B)),
	domenica ? rdp(difensori(A,C)),
	formazioni2 ? out(difensori(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==4,risultati2 ? out(V1);calcolopunteggioa1(P,V1)).
calcolopunteggioa2(Q,V):-
	formazioni2 ? inp(centrocampisti(A,B)),
	domenica ? rdp(centrocampisti(A,C)),
	formazioni2 ? out(centrocampisti(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==4,risultati2 ? out(V1);calcolopunteggioa2(P,V1)).
calcolopunteggioa3(Q,V):-
	formazioni2 ? inp(attaccanti(A,B)),
	domenica ? rdp(attaccanti(A,C)),
	formazioni2 ? out(attaccanti(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==2,risultati2 ? out(V1);calcolopunteggioa3(P,V1)).
result1(Q,V):-
	risultati2 ? inp(A),
	V1 is V+A,
	P is Q+1,
	(P==4,formazioni2 ? out(totale(V1));result1(P,V1)).

calcolopunteggiob:-
	formazioni3 ? inp(portieri(A,B)),
	domenica ? rdp(portieri(A,C)),
	formazioni3 ? out(portieri(A,C)),
	risultati3 ? out(C).
calcolopunteggiob1(Q,V):-
	formazioni3 ? inp(difensori(A,B)),
	domenica ? rdp(difensori(A,C)),
	formazioni3 ? out(difensori(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==4,risultati3 ? out(V1);calcolopunteggiob1(P,V1)).
calcolopunteggiob2(Q,V):-
	formazioni3 ? inp(centrocampisti(A,B)),
	domenica ? rdp(centrocampisti(A,C)),
	formazioni3 ? out(centrocampisti(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==4,risultati3 ? out(V1);calcolopunteggiob2(P,V1)).
calcolopunteggiob3(Q,V):-
	formazioni3 ? inp(attaccanti(A,B)),
	domenica ? rdp(attaccanti(A,C)),
	formazioni3 ? out(attaccanti(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==2,risultati3 ? out(V1);calcolopunteggiob3(P,V1)).
result2(Q,V):-
	risultati3 ? inp(A),
	V1 is V+A,
	P is Q+1,
	(P==4,formazioni3 ? out(totale(V1));result2(P,V1)).

calcolopunteggioc:-
	formazioni4 ? inp(portieri(A,B)),
	domenica ? rdp(portieri(A,C)),
	formazioni4 ? out(portieri(A,C)),
	risultati4 ? out(C).
calcolopunteggioc1(Q,V):-
	formazioni4 ? inp(difensori(A,B)),
	domenica ? rdp(difensori(A,C)),
	formazioni4 ? out(difensori(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==4,risultati4 ? out(V1);calcolopunteggioc1(P,V1)).
calcolopunteggioc2(Q,V):-
	formazioni4 ? inp(centrocampisti(A,B)),
	domenica ? rdp(centrocampisti(A,C)),
	formazioni4 ? out(centrocampisti(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==4,risultati4 ? out(V1);calcolopunteggioc2(P,V1)).
calcolopunteggioc3(Q,V):-
	formazioni4 ? inp(attaccanti(A,B)),
	domenica ? rdp(attaccanti(A,C)),
	formazioni4 ? out(attaccanti(A,C)),
	V1 is V+C,
	P is Q+1,
	(P==2,risultati4 ? out(V1);calcolopunteggioc3(P,V1)).
result3(Q,V):-
	risultati4 ? inp(A),
	V1 is V+A,
	P is Q+1,
	(P==4,formazioni4 ? out(totale(V1));result3(P,V1)).